import .bool
import .connectives
import .leibniz
import .logic
import .nat
constant gcd.gcd_aux : (nat.nat) -> (nat.nat) -> (nat.nat) -> nat.nat.
constant gcd.gcd_aux_body : (nat.nat) -> (nat.nat) -> (nat.nat) -> nat.nat.
axiom gcd.axiom_gcd_aux : forall (p:nat.nat) , (((connectives.equal) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p)).
theorem gcd.eq_gcd_aux : forall (p:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p)) := fun (p : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p))) ((@gcd.axiom_gcd_aux) (p)).
axiom gcd.axiom_gcd_aux_body_O : (((connectives.equal) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) ((nat.O) ))) (fun (m : nat.nat) , fun (n : nat.nat) , m).
theorem gcd.eq_gcd_aux_body_O : (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) ((nat.O) ))) (fun (m : nat.nat) , fun (n : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) ((nat.O) ))) (fun (m : nat.nat) , fun (n : nat.nat) , m)) (@gcd.axiom_gcd_aux_body_O).
noncomputable def gcd.gcd : (nat.nat) -> (nat.nat) -> nat.nat := fun (n : nat.nat) , fun (m : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (((((gcd.gcd_aux) ) (n)) (m)) (n))) (((((gcd.gcd_aux) ) (m)) (n)) (m))) ((((nat.leb) ) (n)) (m)).
theorem gcd.gcd_O_l : forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (m) := fun (m : nat.nat) , (((((@bool.eq_match_bool_type_true) (nat.nat)) (m)) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (y))) (((@nat.eq_leb_body_O) (fun (y : (nat.nat) -> bool.bool) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (m)) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((y) (m))))) (((((@nat.eq_filter_nat_type_O) ((nat.nat) -> bool.bool)) ((nat.leb_body) )) (fun (y : (nat.nat) -> bool.bool) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (m)) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((y) (m))))) ((((@nat.eq_leb) ((nat.O) )) (fun (y : (nat.nat) -> bool.bool) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (m)) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((y) (m))))) (((@gcd.eq_gcd_aux_body_O) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (((y) (m)) ((nat.O) ))) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((((nat.leb) ) ((nat.O) )) (m))))) (((((@nat.eq_filter_nat_type_O) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (((y) (m)) ((nat.O) ))) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((((nat.leb) ) ((nat.O) )) (m))))) ((((@gcd.eq_gcd_aux) ((nat.O) )) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))) (((((bool.match_bool_type) (nat.nat)) (((y) (m)) ((nat.O) ))) (((((gcd.gcd_aux) ) (m)) ((nat.O) )) (m))) ((((nat.leb) ) ((nat.O) )) (m))))) (((@logic.refl_) (nat.nat)) ((((gcd.gcd) ) ((nat.O) )) (m))))))))).
