import .bool
import .connectives
import .leibniz
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
constant nat.leb : (nat.nat) -> (nat.nat) -> bool.bool.
constant nat.leb_body : (nat.nat) -> (nat.nat) -> bool.bool.
axiom nat.axiom_leb : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> bool.bool)) (((nat.leb) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> bool.bool)) ((nat.leb_body) )) (n)).
theorem nat.eq_leb : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> bool.bool)) (((nat.leb) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> bool.bool)) ((nat.leb_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> bool.bool)) (((nat.leb) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> bool.bool)) ((nat.leb_body) )) (n))) ((@nat.axiom_leb) (n)).
axiom nat.axiom_leb_body_O : (((connectives.equal) ((nat.nat) -> bool.bool)) (((nat.leb_body) ) ((nat.O) ))) (fun (m : nat.nat) , (bool.true) ).
theorem nat.eq_leb_body_O : (((leibniz.leibniz) ((nat.nat) -> bool.bool)) (((nat.leb_body) ) ((nat.O) ))) (fun (m : nat.nat) , (bool.true) ) := ((((@connectives.equal_leibniz) ((nat.nat) -> bool.bool)) (((nat.leb_body) ) ((nat.O) ))) (fun (m : nat.nat) , (bool.true) )) (@nat.axiom_leb_body_O).
